SystemOrganization addCategory: #'OB-REST'!

!OBColumn methodsFor: '*ob-rest' stamp: 'avi 5/28/2007 23:56'!
xmlOn: xml
	xml element: 'selection' with: self selection asString.
	xml element: 'children' do:
		[children withIndexDo:
			[:ea :i |
			xml element: 'node' do:
				[xml element: 'label' with: (parent displayStringForChild: ea).
				ea xmlOn: xml]]]! !

!OBBrowser methodsFor: '*ob-rest' stamp: 'avi 5/29/2007 00:08'!
xmlOn: xml
	xml element: 'label' with: self labelString.
	xml element: 'panels' do:
		[panels do:
			[:ea |
			xml element: 'panel' do:
				[xml element: 'type' with: ea class name. 
				ea xmlOn: xml]]]! !

!OBPanel methodsFor: '*ob-rest' stamp: 'avi 5/28/2007 21:12'!
xmlOn: xml
	! !

Object subclass: #OBBrowserGroup
	instanceVariableNames: 'browsers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-REST'!

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:04'!
browserAt: aString do: aBlock
	| browser |
	browser _ browsers at: aString ifAbsent: [^ self].
	^ self withRegistrationHandler: [aBlock value: browser]! !

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 21:44'!
initialize
	browsers _ Dictionary new! !

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:04'!
open: aBrowserOrClass
	self withRegistrationHandler: [aBrowserOrClass open]! !

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 21:55'!
registerBrowser: aBrowser
	| key |
	key _ UUID new asString.
	browsers at: key put: aBrowser.
	^ key! !

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:04'!
withRegistrationHandler: aBlock
	^ [aBlock value]
		on: OBBrowseRequest do: [:n | self registerBrowser: n browser]! !

!OBBrowserGroup methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:12'!
xmlOn: xml
	xml element: 'browsers' do:
		[browsers keysAndValuesDo:
			[:k :v |
			xml element: 'browser' do:
				[xml element: 'label' with: v labelString.
				xml element: 'key' with: k]]]! !

Object subclass: #OBSexprBuilder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-REST'!

!OBSexprBuilder methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:09'!
asString
	^ stream contents! !

!OBSexprBuilder methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:10'!
element: nameString do: aBlock
	stream
		nextPut: $(;
		nextPutAll: nameString;
		nextPut: $ .
	aBlock value.
	stream
		nextPut: $)! !

!OBSexprBuilder methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:10'!
element: nameString with: aString
	stream
		nextPut: $(;
		nextPutAll: nameString;
		nextPut: $ ;
		nextPutAll: aString asString printString;
		nextPut: $)! !

!OBSexprBuilder methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:04'!
initialize
	stream _ String new writeStream! !

WAEntryPoint subclass: #OBEntryPoint
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-REST'!

!OBEntryPoint class methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:12'!
description
	^ 'OmniBrowser'! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:45'!
findColumn: aDictionary browser: aBrowser
	^ aDictionary at: 'column' ifPresent:
		[:col |
		(aBrowser panels detect: [:ea | ea isKindOf: OBColumnPanel] ifNone: [^ nil]) 			columns at: col asNumber ifAbsent: []].
	! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:43'!
handleRequest: aRequest
	| path |
	path _ (aRequest url allButFirst: self basePath size) findTokens: '/'.
	
	path isEmpty ifTrue: [^ self xmlResponse: group].
	
	group browserAt: path first do:
		[:browser |
		self processAction: aRequest fields browser: browser.
		^ (path at: 2 ifAbsent: []) = 'sexpr' ifTrue: [self sexprResponse: browser] ifFalse: [self xmlResponse: browser]].
	
	^ WAResponse notFound: path! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:16'!
initialize
	group _ OBBrowserGroup new.
	group open: OBSystemBrowser! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:21'!
processAction: aDictionary browser: aBrowser
	aDictionary at: 'action' ifPresent:
		[:act |
		act = 'select' ifTrue: [self select: aDictionary browser: aBrowser]]! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/28/2007 22:44'!
select: aDictionary browser: aBrowser
	(self findColumn: aDictionary browser: aBrowser) ifNotNilDo:
		[:column |
		aDictionary at: 'selection' ifPresent:
			[:sel |
			column selection: sel asNumber]]! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:43'!
sexprResponse: anObject
	| builder |
	builder _ OBSexprBuilder new.
	anObject xmlOn: builder.
	^ WAResponse new
		contentType: 'text/plain';
		nextPutAll: builder asString
	! !

!OBEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 5/29/2007 00:43'!
xmlResponse: anObject
	| builder |
	builder _ DomBuilder new.
	anObject xmlOn: builder.
	^ WAResponse new
		contentType: 'text/plain';
		nextPutAll: builder document asString
	! !

!OBColumnPanel methodsFor: '*ob-rest' stamp: 'avi 5/29/2007 00:09'!
xmlOn: xml
	xml element: 'minPanes' with: self minPanes asString.
	xml element: 'maxPanes' with: self maxPanes asString.
	xml element: 'columns' do:
		[columns withIndexDo:
			[:ea :i |
			xml element: 'column' do:
				[ea xmlOn: xml]]]! !

!OBNode methodsFor: '*ob-rest' stamp: 'avi 5/28/2007 21:35'!
xmlOn: xml
	! !

!OBDefinitionPanel methodsFor: '*ob-rest' stamp: 'avi 5/29/2007 01:00'!
xmlOn: xml
	xml element: 'definition' with: self text.
	xml element: 'selection' do:
		[xml element: 'start' with: self selection first.
		xml element: 'end' with: self selection last]! !
